;------- TASM ASM mnemonics. -------
; Compile this file using:
; Set TASMOPTS = -b
; tasm -80 ThisCode.tas MyBinary.BIN
;-----------------------------------
; Zx81 Program name: VB81 XuR [P_[ZX81 BASIC TEXT CODES].txt] :
; REM   line   name: D=16516/16713 : H=4084/4149

#define ORG  .org       ; TASM cross-assembler definitions
#define equ  .equ

;------- Rom and Ram Symbols -------
PRINT_AT equ $08F5
OUT_NUM equ $0A98
TOKENS equ $094B
PRINT_A equ $0010
RAM_S_POSN equ $4039
RAM_D_FILE equ $400C
RAM_LAST_K equ $4025
ERROR_1 equ $0008


ORG $4084 ; [@16516/@h4084]
	LD D,$15 
	PUSH DE 
	LD BC,$1400 
	CALL PRINT_AT ; [PRINT-AT]
	LD HL,$407D 
NL:
	LD B,(HL) 
	INC HL 
	LD C,(HL) 
	CALL OUT_NUM ; [OUT-NUM]
	POP DE 
	LD E,$16 
	PUSH DE 
	INC HL 
	LD B,(HL) 
	DEC B 
	INC HL 
	INC HL 
	XOR A 
NEWLINE:
	JR NZ, NL ; [$4090:16528]
START:
	LD A,(HL) 
	CP $7E 
	JR NZ, NOT7E ; [$40B0:16560]
	LD A,B 
	LD BC,$0005 
	ADD HL,BC 
	SUB C 
	LD B,A 
	JR SKIP ; [$40BC:16572]
NOT7E:
	BIT 6,A 
	PUSH AF 
	PUSH BC 
	CALL NZ,TOKENS ; [TOKENS]
	POP BC 
	POP AF 
	CALL Z,PRINT_A ; [Print-A]
SKIP:
	INC HL 
	LD A,(RAM_S_POSN+1) ; GET S-POSN
	CP $03 
	JR NZ, NOSCROLL ; [$4115:16661]
	POP DE 
	DEC D 
	DEC E 
	XOR A 
	CP D 
	JR NZ, MISS ; [$40CE:16590]
	LD D,E 
	LD E,$22 
MISS:
	PUSH DE 
	PUSH BC 
	PUSH HL 
	JR NZ, NOPAUSE ; [$40F1:16625]
	LD HL,(RAM_D_FILE) ; GET D-FILE
	LD DE,$02F8 
	ADD HL,DE 
	PUSH HL 
	LD (HL),$80 
PAUSE:
	LD HL,(RAM_LAST_K) ; GET LAST-K
	LD DE,$FD7F 
	AND A 
	SBC HL,DE 
	ADD HL,DE 
	CALL Z,ERROR_1 ; []*BIOS ROM*
	INC C 
	INC H 
	JR Z, PAUSE ; [$40DD:16605]
	POP HL 
	LD (HL),$00 
NOPAUSE:
	LD HL,(RAM_D_FILE) ; GET D-FILE
	PUSH HL 
	LD DE,$0021 
	ADD HL,DE 
	POP DE 
	LD BC,$02B5 
	LDIR 
	XOR A 
	LD B,$20 
LOOP:
	INC DE 
	LD (DE),A 
	DJNZ LOOP ; [$4102:16642]
	LD A,(RAM_S_POSN) ; GET S-POSN
	LD C,A 
	LD A,$21 
	SUB C 
	LD C,A 
	LD B,$14 
	CALL PRINT_AT ; [PRINT-AT]
	POP HL 
	POP BC 
NOSCROLL:
	DJNZ START ; [$40A2:16546]
	LD A,$76 
	RST 10H ; Display= A reg.
	INC HL 
	LD A,(HL) 
	CP $76 
	JR NZ, NEWLINE ; [$40A0:16544]
	POP DE 
	RET ; ==========================
.end

